#clear the memory
rm(list=ls())

#change the current directory
setwd("D:/DataMining/Databases_for_mining/dataset_for_soft_dev_and_comparison/svm/tutoriel")

#load the dataset
df <- read.table("data_svm.txt",header=T,sep="\t",row.names=1)
print(summary(df))

#graphical representation
plot(df$x1,df$x2,type="n")
text(df$x1,df$x2,rownames(df),col=c("blue","red")[df$y],cex=0.75)
     
#load the e1071 library
library(e1071)

#fit a linear SVM - do not scale the data
mlin <- svm(y ~ x1+x2, data=df, kernel="linear",scale=F)
print(mlin)

#properties of the object
print(attributes(mlin))

#index of the support vector
print((rownames(df))[mlin$index])

#insert them into the graph
points(df$x1[mlin$index],df$x2[mlin$index],cex=3,col=rgb(0,0,0))

#weight of the support vector * y
print(mlin$coefs)

#intercept
beta.0 <- -mlin$rho
print(beta.0)

#coefficients
beta.1 <- sum(mlin$coefs*df$x1[mlin$index])
beta.2 <- sum(mlin$coefs*df$x2[mlin$index])
print(paste(beta.1,beta.2))

#the frontier
abline(-beta.0/beta.2,-beta.1/beta.2,col="green")

#the "margin" frontiers
abline((-beta.0-1.0)/beta.2,-beta.1/beta.2,col="gray")
abline((-beta.0+1.0)/beta.2,-beta.1/beta.2,col="gray")
